// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_ThreadImpl.C,v 1.2 1999/01/13 23:24:18 khalsa Exp $

#include <HPCxx_Thread.h>
#include <HPCxx_Runnable.h>
#include <HPCxx_ThreadImpl.h>


void HPCxx_TulipThread::run (void)
{
  if (runnable_) runnable_->run();
  if (hpcxx_thread_) hpcxx_thread_->run();
}

HPCxx_ThreadImpl::HPCxx_ThreadImpl(void)
{
  thread_ = new HPCxx_TulipThread();
}

HPCxx_ThreadImpl::HPCxx_ThreadImpl(HPCxx_Thread* hpcxx_thread)
{
  thread_ = new HPCxx_TulipThread(hpcxx_thread);
}


HPCxx_ThreadImpl::HPCxx_ThreadImpl(const HPCxx_ThreadImpl& thread)
{
  thread_ = new HPCxx_TulipThread(thread.thread_->runnable_,
				  thread.thread_->hpcxx_thread_);
}


HPCxx_ThreadImpl::HPCxx_ThreadImpl(HPCxx_Runnable* runnable, HPCxx_Thread*
				   hpcxx_thread)
{
  thread_ = new HPCxx_TulipThread(runnable, hpcxx_thread);
}

// How does this thread know when the other
// is finished.  Can you start the new thread?
// I think this method should go away.
//
HPCxx_ThreadImpl& HPCxx_ThreadImpl::operator=(const HPCxx_ThreadImpl& thread)
{
  if (this == &thread) return(*this); // self-assignment

  thread_ = new HPCxx_TulipThread(thread.thread_->runnable_,
				  thread.thread_->hpcxx_thread_);

  return(*this);
}

HPCxx_ThreadImpl::~HPCxx_ThreadImpl()
{
  delete thread_;
}
