// HPC++ Run Time Sytem Library
// Extreme! Computing Lab - Computer Science Department
// Copyright (c) 1997 Indiana University
// Authors: Pete Beckman, Dennis Gannon, Todd Green, and Liz Johnson
//
// $Id: HPCxx_MutexImpl.C,v 1.1 1999/04/17 01:00:21 kate Exp $

#include <HPCxx_MutexImpl.h>

HPCxx_MutexImpl::HPCxx_MutexImpl()
{
  nexus_mutex_init(&mutex_, NULL);
}

HPCxx_MutexImpl::HPCxx_MutexImpl(const HPCxx_MutexImpl& mutex)
  : mutex_(mutex.mutex_)
{
}

HPCxx_MutexImpl& HPCxx_MutexImpl::operator=(const HPCxx_MutexImpl& mutex)
{
  if (this == &mutex) return *this; // check for self-assignment

  nexus_mutex_destroy(&mutex_); // get rid of the old mutex;
  mutex_ = mutex.mutex_;

  return *this;
}

HPCxx_MutexImpl::~HPCxx_MutexImpl()
{
  nexus_mutex_destroy(&mutex_);
}

int HPCxx_MutexImpl::lock()
{
  return(nexus_mutex_lock(&mutex_));
}

int HPCxx_MutexImpl::unlock()
{
  return(nexus_mutex_unlock(&mutex_));
}
